#!/usr/bin/env python
#%matplotlib inline
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
import os
import pylab
from scipy import stats, integrate
import seaborn as sns
sns.set(color_codes=True)
import matplotlib.pyplot
from pandas.plotting import autocorrelation_plot
from statsmodels.graphics.tsaplots import plot_pacf
import statsmodels.api as sm

class EDA_matplotlib(object):
    """ The main EDA_matplotlib object 
    
    The EDA_matplotlib is an python Class which provides methods 
    for EDA using the in-built matplotlib library .
    The generated plots can also be downloaded using this object.
    It is formed from the pandas dataframe 
    
    :param data: pandas dataFrame
    :return: :class:`matplotlib` object
    
    Usage:: 
            >>> data_file = "datafile.csv"
            >>> data = pd.read_csv(data_file)
            >>> matplotlib_class = EDA_matplotlib(data)
    
    """
    
    def __init__(self, data):
        """ Initializing the class variables """
        self.data = data
        self.num_cols = self.data.select_dtypes(include=[np.number])
        ''' 
        list of all numerical column names in the data 
        '''
        self.cat_cols = self.data.select_dtypes(include=['O'])
        '''
        list of all categorical column names in the data 
        '''
        self.dload = None
        '''
        str,
        specifies the path of the parent/base folder
        '''
        self.folder_name = None
        '''
        str,
        folder name where the plot has to saved
        '''
        self.download = None
        '''
        bool,
        it is set True if the plot has to be downloaded, else False
        '''


    def download_plot(self,plt,folder_name,i):
        """ This function is used to download the matplotlib plots

        :param         plt: Figure,
                            the Figure instance generated by the plot.
        :param folder_name: str,
                            it specifies the folder name where the plot has to be saved.
        :param           i: str,
                            it specifies the filename.
        """
        save_dir = self.dload+"/"+folder_name
        print(save_dir)
        if os.path.exists(save_dir):
            pass
        else:
            os.mkdir(self.dload+'/'+folder_name)
        plt.savefig(self.dload + "/"+folder_name+"/" + i + '.png')

    def set_base_details(self,base_folder,folder_name,download):
        """ This function is used to set the base folder, where all plots will be stored, such as tmp.
        It also sets the folder name in which  the plots will be individually stored only if the download parameter is set to True.

        :param base_folder: str,
                            it specifies the path of the parent/base folder.
        :param folder_name: str,
                            it specifies the folder name where the plot has to be saved.
        :param    download: bool,
                            it is set True if the plot has to be downloaded, else False.
        """
        self.dload = base_folder
        self.folder_name = folder_name
        self.download = download

    def plot_histogram_matplotlib(self,column_name):
        """ This function is used to plot histogram.

        Histograms are used to estimate the distribution of numerical columns.

        :param column_name: list of numerical column names whose histogram are to be built .
        """
        if not isinstance(column_name, list):
            column_name = [column_name]
        for i in column_name:
            plt.figure()
            binwidth = 1
            plt.hist(self.data[i], bins=20, rwidth=0.5)
            plt.xlabel(i)
            plt.ylabel('Frequency')
            plt.title("Histogram for " + i)
            plt.legend()

            if self.download:
                self.download_plot(plt,self.folder_name,i)
            elif self.download == False:
                plt.show()

    def matplotlib_plot_frequency(self,column_name):
        """ This function is used for frequency plots.

        It is useful for univariate analysis of categorical variables by finding no. of occurrences.

        :param column_name: list of categorical column names whose frequency plot are to be built.
        """
        if not isinstance(column_name, list):
            column_name = [column_name]
        for i in column_name:
            plt.figure()
            plt.title("Frequency - " + i)
            fig = self.data[i].value_counts().plot(kind='bar', fontsize=26).get_figure()
            if self.download:
                self.download_plot(fig,self.folder_name,i)
            elif self.download == False:
                plt.show()

    def matplotlib_plot_distribution(self,column_name):
        """ This function generates Distribution plots.

        Suitable for comparing range and distribution for groups of numerical data

        :param column_name: list of numerical column names whose distribution plots are to be built.
        """
        for i in column_name:
            plt.figure()
            sns_plot = sns.distplot(self.num_cols[i]).get_figure()
            if self.download:
                self.download_plot(sns_plot,self.folder_name,i)
            elif self.download == False:
                plt.show()

    def matplotlib_plot_qq(self,numerical_column):
        """ This function generates Quantile-Quantile plot.

        Used to check whether the data follows some theoretical distribution by using their quantiles.

        This may take some time to generate

        :param numerical_column: str,
                                 numerical column name whose Q-Q plot has to be built
        """

        if not isinstance(numerical_column, list):
            numerical_column = [numerical_column]

        for each_numerical in numerical_column:
            fig, ax = plt.subplots()
            stats.probplot(self.data[each_numerical], dist="norm", plot=ax)
            ax.set_title("Q-Q plot : "+each_numerical)
            if self.download:
                self.download_plot(fig,self.folder_name,each_numerical)
            elif self.download == False:
                plt.show()

    def matplotlib_heatmap(self,categorical_column_1,categorical_column_2):
        """  Function for Analysis of two categorical variable using heatmaps.

        :param categorical_column_1: list of categorical column names.
        :param categorical_column_2: list of categorical column names.

        With combinations of attributes in each list, heatmaps are formed.
        """

        save_dir = self.dload+"/"+self.folder_name
        for each_categorical_1 in categorical_column_1:
            for each_categorical_2 in categorical_column_2:
                cross_df = pd.crosstab(self.data[each_categorical_1],self.data[each_categorical_2])
                cross_list = cross_df.values.tolist()

                x=cross_df.columns.values.tolist()
                y=cross_df.index.values.tolist()
                z = cross_list
                fontsize_pt = plt.rcParams['ytick.labelsize']
#                 dpi = 72.27
#                 matrix_height_pt = fontsize_pt * cross_df.shape[0]
#                 matrix_height_in = matrix_height_pt / dpi
#                 top_margin = 0.04  # in percentage of the figure height
#                 bottom_margin = 0.04 # in percentage of the figure height
#                 figure_height = matrix_height_in / (1 - top_margin - bottom_margin)
                fig, ax = plt.subplots()#figsize=(6,figure_height), gridspec_kw=dict(top=1-top_margin, bottom=bottom_margin))
                ax = sns.heatmap(z, xticklabels=x,yticklabels=y,ax=ax)
                if self.download:
                    if os.path.exists(save_dir):
                        pass
                    else:
                        os.mkdir(self.dload+'/'+self.folder_name)
                    plt.savefig(self.dload + "/"+self.folder_name+"/" + (each_categorical_1+each_categorical_2) + '.png')
                    plt.close()
                else:
                    plt.show()



    def matplotlib_correlation(self):
        """
        Plots correlation heatmap across all numerical variables. It finds the dependency between the numerical attributes.

        """
        corr = self.data.corr()
        save_dir = self.dload+"/"+self.folder_name
        sns.heatmap(corr, xticklabels=corr.columns.values,yticklabels=corr.columns.values)
        if self.download:
            if os.path.exists(save_dir):
                pass
            else:
                os.mkdir(self.dload+'/'+self.folder_name)
            plt.savefig(self.dload + "/"+self.folder_name+"/" + "Correlation" + '.png')
        else:
            plt.show()


    def matplotlib_box_plot(self):
        """
        Generates box-plot for all numerical columns. Gives the quartiles, min, max and the outliers of the attributes .

        """
        save_dir = self.dload+"/"+self.folder_name
        if self.download:
            if os.path.exists(save_dir):
                pass
            else:
                os.mkdir(self.dload+'/'+self.folder_name)
            for i in self.num_cols:
                self.data.boxplot(i)
                plt.savefig(self.dload + "/"+self.folder_name+"/" + i + '.png')
                plt.close()
        else:
            for i in self.num_cols:
                self.data.boxplot(i)
                plt.show()



    def plot_all_histogram_matplotlib(self):
        """
        Generates histograms for all numerical variables.

        """
        for i in self.num_cols:
            plt.figure()
            binwidth = 1
            plt.hist(self.data[i], bins=20, rwidth=0.5)
            plt.xlabel(i)
            plt.ylabel('Frequency')
            plt.title("Histogram for " + i)
            plt.legend()
            if self.download:
                self.download_plot(plt,self.folder_name,i)
            elif self.download == False:
                plt.show()

    def plot_all_frequency_matplotlib(self):
        """
        Generates frequency plot for all categorical variables.

        """
        for i in self.cat_cols:
            plt.figure()
            plt.title("Frequency - " + i)
            fig = self.data[i].value_counts().plot(kind='bar', figsize=(20, 16), fontsize=26).get_figure()
            if self.download:
                self.download_plot(fig,self.folder_name,i)
            elif self.download == False:
                plt.show()

    def scatter_plot_matplotlib(self,num_col1,num_col2):
        """ This function generates scatter plots.

        Used for analysis of two numerical variables.

        :param num_col1: list of numerical column names.
        :param num_col2: list of numerical column names.

        With combinations of attributes in each list, the scatter plot is formed.
        """
        if not isinstance(num_col1, list):
            num_col1 = [num_col1]
        if not isinstance(num_col2, list):
            num_col2 = [num_col2]
        for i in num_col1:
            for j in num_col2:
                plt.scatter(self.data[i], self.data[j])
                plt.xlabel(i)
                plt.ylabel(j)
                if self.download:
                    self.download_plot(plt,self.folder_name,(i+j))
                    plt.clf()
                elif self.download == False:
                    plt.show()

    def stacked_histogram(self,num_col,cat_col):
        """ Plots stacked histogram between numerical column and categorical column.

        :param num_col: list of numerical column names.
        :param cat_col: list of categorical column names.

        With combinations of attributes in each list , the histogram is formed .
        """
        if not isinstance(num_col, list):
            num_col = [num_col]
        if not isinstance(cat_col, list):
            cat_col = [cat_col]
        for i in num_col:
            for j in cat_col:
                table = pd.crosstab(index=self.data[i], columns=self.data[j])
                table.plot(kind="bar", figsize=(8,8),stacked=True)
                if self.download:
                    self.download_plot(plt,self.folder_name,(i+j))
                    plt.clf()
                elif self.download == False:
                    plt.show()

    def matplotlib_ts(self,time_column,target_column):
        """ Plots a time series, with time column on x-axis and target column on y-axis

        :param   time_column: str,
                              name of the column  which is of type time .
        :param target_column: str,
                              the time dependent numerical column name.
        """

        self.data.plot(x=time_column, y=target_column)
        if self.download:
            self.download_plot(plt,self.folder_name,target_column)
        elif self.download == False:
            plt.show()


    def matplotlib_autocorrelation(self,numerical_column):
        """ Generates autocorrelation plot given numerical column

         The correlation of the time series observations is calculated
         with values of the same series at previous times.

        :param numerical_column: str,
                                 the time dependent numerical column name.
        """

        if not isinstance(numerical_column, list):
            numerical_column = [numerical_column]

        for each_numerical in numerical_column:
            fig, ax = plt.subplots()
            autocorrelation_plot(self.data[each_numerical], ax=ax)
            ax.set_title('Auto-correlation plot')
            if self.download:
                self.download_plot(plt,self.folder_name,each_numerical)
            elif self.download == False:
                plt.show()

    def matplotlib_lag(self,numerical_column):
        """ Generates Lag plots

        Lag plots are used to check if a data set or time series is random.
        Random data should not exhibit any structure in the lag plot.
        Non-random structure implies that the underlying data are not random.

        :param numerical_column: str,
                                 the time dependent numerical column name.
        """

        if not isinstance(numerical_column, list):
            numerical_column = [numerical_column]

        for each_numerical in numerical_column:
            fig, ax = plt.subplots()
            pd.plotting.lag_plot(self.data[each_numerical], ax=ax)
            ax.set_title('Lag plot')
            if self.download:
                self.download_plot(plt,self.folder_name,each_numerical)
            elif self.download == False:
                plt.show()


    def matplotlib_pacf(self,numerical_column,lags):
        """ Generates partial auto-correlation plot

        Similar to autocorrelation instead removing the indirect correlations.

        :param numerical_column:  str,
                                  the time dependent numerical column name.
        :param             lags:  int or num,
                                  the number of lags.
        """

        if not isinstance(numerical_column, list):
            numerical_column = [numerical_column]

        for each_numerical in numerical_column:
            fig, ax = plt.subplots()
            plot_pacf(self.data[each_numerical], lags = lags, ax= ax)
            ax.set_title('PACF plot')
            print(self.download)
            if self.download:
                self.download_plot(plt,self.folder_name,each_numerical)
            elif self.download == False:
                plt.show()


    def stl_matplotlib_decomposition(self,time,field):
        """ Decomposes a time series into Trend, Seasonality and Residual (STL)

        :param  time: str,
                      name of the column which is of type time.
        :param field: str,
                      the time dependent numerical column name.
        """
        new = self.data[[time,field]]
        new[time] = pd.to_datetime(new[time])
        new = new.set_index(time)
        new.interpolate(inplace=True)
        res = sm.tsa.seasonal_decompose(new[field],freq=30)
        resplot = res.plot()
        if self.download:
            self.download_plot(plt,self.folder_name,field)
        elif self.download == False:
            plt.show()
